blob: 00ebb2c0f1ed9ffb6d99d68d31b6a43a584c5846 [file] [log] [blame]
Tristan Muntsinger82c10502019-10-15 14:49:19 -07001#!/bin/bash
2
3# Copyright 2019 Google Inc. All rights reserved.
4
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8
9# http://www.apache.org/licenses/LICENSE-2.0
10
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17source "${ANDROID_BUILD_TOP}/external/shflags/src/shflags"
18
Tristan Muntsinger34569112019-10-16 22:10:54 -070019DEFINE_boolean p1 \
20 false "Only generate/write the 1st partition (loader1)" "1"
21DEFINE_boolean p2 \
22 false "Only generate/write the 2nd partition (env)" "2"
23DEFINE_boolean p3 \
24 false "Only generate/write the 3rd partition (loader2)" "3"
25DEFINE_boolean p4 \
26 false "Only generate/write the 4th partition (trust)" "4"
27DEFINE_boolean p5 \
28 false "Only generate/write the 5th partition (rootfs)" "5"
29
30FLAGS_HELP="USAGE: $0 <KERNEL_DIR> [IMAGE] [flags]"
Tristan Muntsinger82c10502019-10-15 14:49:19 -070031
32FLAGS "$@" || exit $?
33eval set -- "${FLAGS_ARGV}"
34
Tristan Muntsinger34569112019-10-16 22:10:54 -070035if [ ${FLAGS_p1} -eq ${FLAGS_FALSE} ] &&
36 [ ${FLAGS_p2} -eq ${FLAGS_FALSE} ] &&
37 [ ${FLAGS_p3} -eq ${FLAGS_FALSE} ] &&
38 [ ${FLAGS_p4} -eq ${FLAGS_FALSE} ] &&
39 [ ${FLAGS_p5} -eq ${FLAGS_FALSE} ]; then
40 FLAGS_p1=${FLAGS_TRUE}
41 FLAGS_p2=${FLAGS_TRUE}
42 FLAGS_p3=${FLAGS_TRUE}
43 FLAGS_p4=${FLAGS_TRUE}
44 FLAGS_p5=${FLAGS_TRUE}
45fi
46
Tristan Muntsinger82c10502019-10-15 14:49:19 -070047for arg in "$@" ; do
48 if [ -z $KERNEL_DIR ]; then
49 KERNEL_DIR=$arg
50 elif [ -z $IMAGE ]; then
51 IMAGE=$arg
52 else
53 flags_help
54 exit 1
55 fi
56done
57
Tristan Muntsingere4eeded2019-10-15 20:26:15 -070058USE_IMAGE=`[ -z "${IMAGE}" ] && echo "0" || echo "1"`
Tristan Muntsinger1f28d1f2019-10-16 22:53:55 -070059OVERWRITE=`[ -e "${IMAGE}" ] && echo "1" || echo "0"`
60if [ -z $KERNEL_DIR ]; then
Tristan Muntsinger82c10502019-10-15 14:49:19 -070061 flags_help
62 exit 1
63fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -070064if [ ! -e "${KERNEL_DIR}" ]; then
65 echo "error: can't find '${KERNEL_DIR}'. aborting..."
66 exit 1
67fi
68
69# escalate to superuser
70if [ $UID -ne 0 ]; then
71 cd ${ANDROID_BUILD_TOP}
72 . ./build/envsetup.sh
73 lunch ${TARGET_PRODUCT}-${TARGET_BUILD_VARIANT}
74 mmma external/u-boot
75 cd -
76 exec sudo -E "${0}" ${@}
77fi
78
Tristan Muntsinger1f28d1f2019-10-16 22:53:55 -070079if [ $OVERWRITE -eq 1 ]; then
80 OVERWRITE_IMAGE=${IMAGE}
81 IMAGE=`mktemp`
82fi
83
Tristan Muntsingere4eeded2019-10-15 20:26:15 -070084if [ $USE_IMAGE -eq 0 ]; then
85 init_devs=`lsblk --nodeps -oNAME -n`
86 echo "Reinsert device (to write to) into PC"
87 while true; do
88 devs=`lsblk --nodeps -oNAME -n`
89 new_devs="$(echo -e "${init_devs}\n${devs}" | sort | uniq -u | awk 'NF')"
90 num_devs=`echo "${new_devs}" | wc -l`
91 if [[ "${new_devs}" == "" ]]; then
92 num_devs=0
93 fi
94 if [[ ${num_devs} -gt 1 ]]; then
95 echo "error: too many new devices detected! aborting..."
96 exit 1
97 fi
98 if [[ ${num_devs} -eq 1 ]]; then
99 if [[ "${new_devs}" != "${mmc_dev}" ]]; then
100 if [[ "${mmc_dev}" != "" ]]; then
101 echo "error: block device name mismatch ${new_devs} != ${mmc_dev}"
102 echo "Reinsert device (to write to) into PC"
103 fi
104 mmc_dev=${new_devs}
105 continue
106 fi
107 echo "${init_devs}" | grep "${mmc_dev}" >/dev/null
108 if [[ $? -eq 0 ]]; then
109 init_devs="${devs}"
110 continue
111 fi
112 break
113 fi
114 done
115 # now inform the user
116 echo "Detected device at /dev/${mmc_dev}"
117fi
118
Tristan Muntsinger34569112019-10-16 22:10:54 -0700119if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ]; then
120 cd ${ANDROID_BUILD_TOP}/external/arm-trusted-firmware
121 CROSS_COMPILE=aarch64-linux-gnu- make PLAT=rk3399 DEBUG=0 ERROR_DEPRECATED=1 bl31
122 export BL31="${ANDROID_BUILD_TOP}/external/arm-trusted-firmware/build/rk3399/release/bl31/bl31.elf"
123 cd -
124fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700125
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700126cd ${ANDROID_BUILD_TOP}/external/u-boot
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700127
Tristan Muntsinger34569112019-10-16 22:10:54 -0700128if [ ${FLAGS_p2} -eq ${FLAGS_TRUE} ]; then
129 tmpfile=`mktemp`
130 bootenv=`mktemp`
131 cat > ${tmpfile} << "EOF"
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700132bootdelay=2
133baudrate=1500000
134scriptaddr=0x00500000
135boot_targets=mmc1 mmc0
136bootcmd=run distro_bootcmd
137distro_bootcmd=for target in ${boot_targets}; do run bootcmd_${target}; done
138bootcmd_mmc0=devnum=0; run mmc_boot
139bootcmd_mmc1=devnum=1; run mmc_boot
140mmc_boot=if mmc dev ${devnum}; then ; run scan_for_boot_part; fi
Tristan Muntsingerf06455a2019-10-31 16:08:19 -0700141scan_for_boot_part=part list mmc ${devnum} -bootable devplist; env exists devplist || setenv devplist 1; if test $devnum = 1; then script_type=init; else script_type=boot; fi; for distro_bootpart in ${devplist}; do if fstype mmc ${devnum}:${distro_bootpart} bootfstype; then run find_script; fi; done; setenv devplist; setenv script_type;
142find_script=if test -e mmc ${devnum}:${distro_bootpart} /boot/$script_type.scr; then echo Found U-Boot script /boot/$script_type.scr; run run_scr; fi
143run_scr=load mmc ${devnum}:${distro_bootpart} ${scriptaddr} /boot/$script_type.scr; source ${scriptaddr}
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700144EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700145 ${ANDROID_HOST_OUT}/bin/mkenvimage -s 32768 -o ${bootenv} - < ${tmpfile}
146fi
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700147
Tristan Muntsinger34569112019-10-16 22:10:54 -0700148if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ] || [ ${FLAGS_p3} -eq ${FLAGS_TRUE} ]; then
149 make ARCH=arm CROSS_COMPILE=aarch64-linux-gnu- rock-pi-4-rk3399_defconfig
150 if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ]; then
151 make ARCH=arm CROSS_COMPILE=aarch64-linux-gnu- -j`nproc`
152 fi
153 if [ ${FLAGS_p3} -eq ${FLAGS_TRUE} ]; then
154 make ARCH=arm CROSS_COMPILE=aarch64-linux-gnu- u-boot.itb
155 fi
156 if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ]; then
157 idbloader=`mktemp`
158 ${ANDROID_HOST_OUT}/bin/mkimage -n rk3399 -T rksd -d tpl/u-boot-tpl.bin ${idbloader}
159 cat spl/u-boot-spl.bin >> ${idbloader}
160 fi
161fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700162cd -
163
Tristan Muntsinger34569112019-10-16 22:10:54 -0700164if [ ${FLAGS_p5} -eq ${FLAGS_TRUE} ]; then
165 ${ANDROID_BUILD_TOP}/kernel/tests/net/test/build_rootfs.sh -a arm64 -s buster -n ${IMAGE}
166 if [ $? -ne 0 ]; then
167 echo "error: failed to build rootfs. exiting..."
168 exit 1
169 fi
170 truncate -s +3G ${IMAGE}
171 e2fsck -f ${IMAGE}
172 resize2fs ${IMAGE}
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700173
Tristan Muntsinger34569112019-10-16 22:10:54 -0700174 mntdir=`mktemp -d`
175 mount ${IMAGE} ${mntdir}
176 if [ $? != 0 ]; then
177 echo "error: unable to mount ${IMAGE} ${mntdir}"
178 exit 1
179 fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700180
Tristan Muntsinger34569112019-10-16 22:10:54 -0700181 cat > ${mntdir}/boot/init.cmd << "EOF"
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700182mmc dev 1 0; mmc read 0x02080000 0x1fc0 0x40;
183ethaddr=$ethaddr
184env default -a
185setenv ethaddr $ethaddr
186setenv boot_targets 'mmc1 mmc0 usb0 pxe'
187saveenv
188mmc dev 1 0; mmc read 0x04000000 0x1fc0 0x40;
189mmc dev 0 0; mmc write 0x04000000 0x1fc0 0x40;
190mmc dev 1 0; mmc write 0x02080000 0x1fc0 0x40;
191EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700192 ${ANDROID_BUILD_TOP}/external/u-boot/tools/mkimage \
Tristan Muntsinger5f263952019-10-16 21:12:06 -0700193 -C none -A arm -T script -d ${mntdir}/boot/init.cmd ${mntdir}/boot/init.scr
194
Tristan Muntsinger34569112019-10-16 22:10:54 -0700195 cat > ${mntdir}/boot/boot.cmd << "EOF"
Tristan Muntsingerbcdc07b2019-10-16 22:56:19 -0700196setenv bootcmd_dhcp '
197mw.b ${scriptaddr} 0 0x8000
198mmc dev 0 0
199mmc read ${scriptaddr} 0x1fc0 0x40
200env import -b ${scriptaddr} 0x8000
201mw.b ${scriptaddr} 0 0x8000
202if dhcp ${scriptaddr} manifest.txt; then
203 setenv OldSha ${Sha}
204 setenv Sha
205 env import -t ${scriptaddr} 0x8000 ManifestVersion
Tristan Muntsinger19c66ee2019-11-08 19:10:48 -0800206 echo "Manifest version $ManifestVersion";
Tristan Muntsingerbcdc07b2019-10-16 22:56:19 -0700207 if test "$ManifestVersion" = "1"; then
208 run manifest1
Tristan Muntsinger19c66ee2019-11-08 19:10:48 -0800209 elif test "$ManifestVersion" = "2"; then
210 run manifest2
Tristan Muntsingerbcdc07b2019-10-16 22:56:19 -0700211 else
212 run manifestX
213 fi
214fi'
215setenv manifestX 'echo "***** ERROR: Unknown manifest version! *****";'
216setenv manifest1 '
Tristan Muntsingerbcdc07b2019-10-16 22:56:19 -0700217env import -t ${scriptaddr} 0x8000
218if test "$Sha" != "$OldSha"; then
219 setenv serverip ${TftpServer}
220 setenv loadaddr 0x00200000
221 mmc dev 0 0;
Tristan Muntsingerb0f74ea2019-11-19 20:39:10 -0800222 setenv file $TplSplImg; offset=0x40; size=0x1f80; run tftpget1; setenv TplSplImg
223 setenv file $UbootItb; offset=0x4000; size=0x2000; run tftpget1; setenv UbootItb
224 setenv file $TrustImg; offset=0x6000; size=0x2000; run tftpget1; setenv TrustImg
225 setenv file $RootfsImg; offset=0x8000; size=0; run tftpget1; setenv RootfsImg
226 setenv file $UbootEnv; offset=0x1fc0; size=0x40; run tftpget1; setenv UbootEnv
Tristan Muntsingerbcdc07b2019-10-16 22:56:19 -0700227 mw.b ${scriptaddr} 0 0x8000
228 env export -b ${scriptaddr} 0x8000
229 mmc write ${scriptaddr} 0x1fc0 0x40
230else
231 echo "Already have ${Sha}. Booting..."
232fi'
Tristan Muntsinger19c66ee2019-11-08 19:10:48 -0800233setenv manifest2 '
234env import -t ${scriptaddr} 0x8000
235if test "$DFUethaddr" = "$ethaddr" || test "$DFUethaddr" = ""; then
236 if test "$Sha" != "$OldSha"; then
237 setenv serverip ${TftpServer}
238 setenv loadaddr 0x00200000
239 mmc dev 0 0;
Tristan Muntsingerb0f74ea2019-11-19 20:39:10 -0800240 setenv file $TplSplImg; offset=0x40; size=0x1f80; run tftpget1; setenv TplSplImg
241 setenv file $UbootItb; offset=0x4000; size=0x2000; run tftpget1; setenv UbootItb
242 setenv file $TrustImg; offset=0x6000; size=0x2000; run tftpget1; setenv TrustImg
243 setenv file $RootfsImg; offset=0x8000; size=0; run tftpget1; setenv RootfsImg
244 setenv file $UbootEnv; offset=0x1fc0; size=0x40; run tftpget1; setenv UbootEnv
Tristan Muntsinger19c66ee2019-11-08 19:10:48 -0800245 mw.b ${scriptaddr} 0 0x8000
246 env export -b ${scriptaddr} 0x8000
247 mmc write ${scriptaddr} 0x1fc0 0x40
248 else
249 echo "Already have ${Sha}. Booting..."
250 fi
251else
Tristan Muntsingerb0f74ea2019-11-19 20:39:10 -0800252 echo "Update ${Sha} is not for me. Booting..."
Tristan Muntsinger19c66ee2019-11-08 19:10:48 -0800253fi'
Tristan Muntsingerb0f74ea2019-11-19 20:39:10 -0800254setenv tftpget1 '
255if test "$file" != ""; then
256 mw.b ${loadaddr} 0 0x400000
257 tftp ${file}
258 if test $? = 0; then
259 setenv isGz 0 && setexpr isGz sub .*\\.gz\$ 1 ${file}
260 if test $isGz = 1; then
261 if test ${file} = ${UbootEnv}; then
262 echo "** gzipped env unsupported **"
263 else
264 setexpr boffset ${offset} * 0x200
265 gzwrite mmc 0 ${loadaddr} 0x${filesize} 100000 ${boffset} && echo Updated: ${file}
266 fi
267 elif test ${file} = ${UbootEnv}; then
268 env import -b ${loadaddr} && echo Updated: ${file}
269 else
270 if test $size = 0; then
271 setexpr x $filesize - 1
272 setexpr x $x / 0x1000
273 setexpr x $x + 1
274 setexpr x $x * 0x1000
275 setexpr x $x / 0x200
276 size=0x${x}
277 fi
278 mmc write ${loadaddr} ${offset} ${size} && echo Updated: ${file}
279 fi
Tristan Muntsingerbcdc07b2019-10-16 22:56:19 -0700280 fi
Tristan Muntsingerb0f74ea2019-11-19 20:39:10 -0800281 if test $? != 0; then
282 echo ** UPDATE FAILED: ${file} **
283 fi
284fi'
Tristan Muntsingerbcdc07b2019-10-16 22:56:19 -0700285if mmc dev 1 0; then; else
286 run bootcmd_dhcp;
287fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700288load mmc ${devnum}:${distro_bootpart} 0x02080000 /boot/Image
289load mmc ${devnum}:${distro_bootpart} 0x04000000 /boot/uInitrd
290load mmc ${devnum}:${distro_bootpart} 0x01f00000 /boot/dtb/rockchip/rk3399-rock-pi-4.dtb
291setenv finduuid "part uuid mmc ${devnum}:${distro_bootpart} uuid"
292run finduuid
293setenv bootargs "earlycon=uart8250,mmio32,0xff1a0000 console=ttyS2,1500000n8 loglevel=7 root=PARTUUID=${uuid} rootwait rootfstype=ext4 sdhci.debug_quirks=0x20000000"
294booti 0x02080000 0x04000000 0x01f00000
295EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700296 ${ANDROID_HOST_OUT}/bin/mkimage \
297 -C none -A arm -T script -d ${mntdir}/boot/boot.cmd ${mntdir}/boot/boot.scr
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700298
Tristan Muntsinger34569112019-10-16 22:10:54 -0700299 cd ${KERNEL_DIR}
300 export PATH=${ANDROID_BUILD_TOP}/prebuilts/clang/host/linux-x86/clang-r353983c/bin:$PATH
301 export PATH=${ANDROID_BUILD_TOP}/prebuilts/gcc/linux-x86/aarch64/aarch64-linux-android-4.9/bin:$PATH
302 make ARCH=arm64 CC=clang CROSS_COMPILE=aarch64-linux-androidkernel- \
303 CLANG_TRIPLE=aarch64-linux-gnu- rockpi4_defconfig
304 make ARCH=arm64 CC=clang CROSS_COMPILE=aarch64-linux-androidkernel- \
305 CLANG_TRIPLE=aarch64-linux-gnu- -j`nproc`
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700306
Tristan Muntsinger34569112019-10-16 22:10:54 -0700307 cp ${KERNEL_DIR}/arch/arm64/boot/Image ${mntdir}/boot/
308 mkdir -p ${mntdir}/boot/dtb/rockchip/
309 cp ${KERNEL_DIR}/arch/arm64/boot/dts/rockchip/rk3399-rock-pi-4.dtb ${mntdir}/boot/dtb/rockchip/
310 cd -
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700311
Tristan Muntsinger34569112019-10-16 22:10:54 -0700312 mount -o bind /proc ${mntdir}/proc
313 mount -o bind /sys ${mntdir}/sys
314 mount -o bind /dev ${mntdir}/dev
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700315
Tristan Muntsinger34569112019-10-16 22:10:54 -0700316 echo "Installing required packages..."
317 chroot ${mntdir} /bin/bash <<EOF
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700318apt-get update
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700319apt-get install -y -f initramfs-tools u-boot-tools network-manager openssh-server sudo man-db vim git dpkg-dev cdbs debhelper config-package-dev gdisk eject lzop binfmt-support ntpdate
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700320EOF
321
Tristan Muntsinger34569112019-10-16 22:10:54 -0700322 echo "Turning on DHCP client..."
323 cat >${mntdir}/etc/systemd/network/dhcp.network <<EOF
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700324[Match]
325Name=en*
326
327[Network]
328DHCP=yes
329EOF
330
Tristan Muntsinger34569112019-10-16 22:10:54 -0700331 chroot ${mntdir} /bin/bash << "EOT"
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700332echo "Adding user vsoc-01 and groups..."
333useradd -m -G kvm,sudo -d /home/vsoc-01 --shell /bin/bash vsoc-01
334echo -e "cuttlefish\ncuttlefish" | passwd
335echo -e "cuttlefish\ncuttlefish" | passwd vsoc-01
336EOT
337
Tristan Muntsinger34569112019-10-16 22:10:54 -0700338 echo "Cloning android-cuttlefish..."
339 cd ${mntdir}/home/vsoc-01
340 git clone https://github.com/google/android-cuttlefish.git
341 cd -
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700342
Tristan Muntsinger34569112019-10-16 22:10:54 -0700343 echo "Creating led script..."
344 cat > ${mntdir}/usr/local/bin/led << "EOF"
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700345#!/bin/bash
346
347if [ "$1" == "--start" ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700348 echo 125 > /sys/class/gpio/export
349 echo out > /sys/class/gpio/gpio125/direction
350 chmod 666 /sys/class/gpio/gpio125/value
351 echo 0 > /sys/class/gpio/gpio125/value
352 exit 0
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700353fi
354
355if [ "$1" == "--stop" ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700356 echo 0 > /sys/class/gpio/gpio125/value
357 echo 125 > /sys/class/gpio/unexport
358 exit 0
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700359fi
360
361if [ ! -e /sys/class/gpio/gpio125/value ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700362 echo "error: led service not initialized"
363 exit 1
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700364fi
365
366if [ "$1" == "0" ] || [ "$1" == "off" ] || [ "$1" == "OFF" ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700367 echo 0 > /sys/class/gpio/gpio125/value
368 exit 0
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700369fi
370
371if [ "$1" == "1" ] || [ "$1" == "on" ] || [ "$1" == "ON" ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700372 echo 1 > /sys/class/gpio/gpio125/value
373 exit 0
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700374fi
375
376echo "usage: led <0|1>"
377exit 1
378EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700379 chown root:root ${mntdir}/usr/local/bin/led
380 chmod 755 ${mntdir}/usr/local/bin/led
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700381
Tristan Muntsinger34569112019-10-16 22:10:54 -0700382 echo "Creating led service..."
383 cat > ${mntdir}/etc/systemd/system/led.service << EOF
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700384[Unit]
385 Description=led service
386 ConditionPathExists=/usr/local/bin/led
387
388[Service]
389 Type=oneshot
390 ExecStart=/usr/local/bin/led --start
391 ExecStop=/usr/local/bin/led --stop
392 RemainAfterExit=true
393 StandardOutput=journal
394
395[Install]
396 WantedBy=multi-user.target
397EOF
398
Tristan Muntsinger34569112019-10-16 22:10:54 -0700399 echo "Creating SD duplicator script..."
400 cat > ${mntdir}/usr/local/bin/sd-dupe << "EOF"
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700401#!/bin/bash
402led 0
403
404src_dev=mmcblk0
405dest_dev=mmcblk1
406part_num=p5
407
408if [ -e /dev/mmcblk0p5 ]; then
Tristan Muntsinger34569112019-10-16 22:10:54 -0700409 led 1
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700410
Tristan Muntsinger34569112019-10-16 22:10:54 -0700411 sgdisk -Z -a1 /dev/${dest_dev}
412 sgdisk -a1 -n:1:64:8127 -t:1:8301 -c:1:loader1 /dev/${dest_dev}
413 sgdisk -a1 -n:2:8128:8191 -t:2:8301 -c:2:env /dev/${dest_dev}
414 sgdisk -a1 -n:3:16384:24575 -t:3:8301 -c:3:loader2 /dev/${dest_dev}
415 sgdisk -a1 -n:4:24576:32767 -t:4:8301 -c:4:trust /dev/${dest_dev}
416 sgdisk -a1 -n:5:32768:- -A:5:set:2 -t:5:8305 -c:5:rootfs /dev/${dest_dev}
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700417
Tristan Muntsinger34569112019-10-16 22:10:54 -0700418 src_block_count=`tune2fs -l /dev/${src_dev}${part_num} | grep "Block count:" | sed 's/.*: *//'`
419 src_block_size=`tune2fs -l /dev/${src_dev}${part_num} | grep "Block size:" | sed 's/.*: *//'`
420 src_fs_size=$(( src_block_count*src_block_size ))
421 src_fs_size_m=$(( src_fs_size / 1024 / 1024 + 1 ))
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700422
Tristan Muntsinger34569112019-10-16 22:10:54 -0700423 dd if=/dev/${src_dev}p1 of=/dev/${dest_dev}p1 conv=sync,noerror status=progress
424 dd if=/dev/${src_dev}p2 of=/dev/${dest_dev}p2 conv=sync,noerror status=progress
425 dd if=/dev/${src_dev}p3 of=/dev/${dest_dev}p3 conv=sync,noerror status=progress
426 dd if=/dev/${src_dev}p4 of=/dev/${dest_dev}p4 conv=sync,noerror status=progress
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700427
Tristan Muntsinger34569112019-10-16 22:10:54 -0700428 echo "Writing ${src_fs_size_m} MB: /dev/${src_dev} -> /dev/${dest_dev}..."
429 dd if=/dev/${src_dev}${part_num} of=/dev/${dest_dev}${part_num} bs=1M conv=sync,noerror status=progress
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700430
Tristan Muntsinger34569112019-10-16 22:10:54 -0700431 echo "Expanding /dev/${dest_dev}${part_num} filesystem..."
432 e2fsck -fy /dev/${dest_dev}${part_num}
433 resize2fs /dev/${dest_dev}${part_num}
434 tune2fs -O has_journal /dev/${dest_dev}${part_num}
435 e2fsck -fy /dev/${dest_dev}${part_num}
436 sync /dev/${dest_dev}
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700437
Tristan Muntsinger34569112019-10-16 22:10:54 -0700438 echo "Cleaning up..."
439 mount /dev/${dest_dev}${part_num} /media
440 chroot /media /usr/local/bin/install-cleanup
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700441
Tristan Muntsinger34569112019-10-16 22:10:54 -0700442 if [ $? == 0 ]; then
443 echo "Successfully copied Rock Pi image!"
444 while true; do
445 led 1; sleep 0.5
446 led 0; sleep 0.5
447 done
448 else
449 echo "Error while copying Rock Pi image"
450 while true; do
451 led 1; sleep 0.1
452 led 0; sleep 0.1
453 done
454 fi
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700455else
Tristan Muntsinger34569112019-10-16 22:10:54 -0700456 echo "Expanding /dev/${dest_dev}${part_num} filesystem..."
457 e2fsck -fy /dev/${dest_dev}${part_num}
458 resize2fs /dev/${dest_dev}${part_num}
459 tune2fs -O has_journal /dev/${dest_dev}${part_num}
460 e2fsck -fy /dev/${dest_dev}${part_num}
461 sync /dev/${dest_dev}
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700462
Tristan Muntsinger34569112019-10-16 22:10:54 -0700463 echo "Cleaning up..."
464 /usr/local/bin/install-cleanup
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700465fi
466EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700467 chmod +x ${mntdir}/usr/local/bin/sd-dupe
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700468
Tristan Muntsinger34569112019-10-16 22:10:54 -0700469 echo "Creating SD duplicator service..."
470 cat > ${mntdir}/etc/systemd/system/sd-dupe.service << EOF
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700471[Unit]
472 Description=Duplicate SD card rootfs to eMMC on Rock Pi
473 ConditionPathExists=/usr/local/bin/sd-dupe
474 After=led.service
475
476[Service]
477 Type=simple
478 ExecStart=/usr/local/bin/sd-dupe
479 TimeoutSec=0
480 StandardOutput=tty
481
482[Install]
483 WantedBy=multi-user.target
484EOF
485
Tristan Muntsinger34569112019-10-16 22:10:54 -0700486 echo "Creating cleanup script..."
487 cat > ${mntdir}/usr/local/bin/install-cleanup << "EOF"
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700488#!/bin/bash
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700489echo "Installing cuttlefish-common package..."
490echo "nameserver 8.8.8.8" > /etc/resolv.conf
491MAC=`ip link | grep eth0 -A1 | grep ether | sed 's/.*\(..:..:..:..:..:..\) .*/\1/'`
492sed -i " 1 s/.*/& rockpi-${MAC}/" /etc/hosts
493sudo hostnamectl set-hostname "rockpi-${MAC}"
494
495dpkg --add-architecture amd64
496until ping -c1 ftp.debian.org; do sleep 1; done
497ntpdate time.google.com
498while true; do
499 apt-get -o Acquire::Check-Valid-Until=false update
500 if [ $? != 0 ]; then sleep 1; continue; fi
501 apt-get install -y -f libc6:amd64 qemu-user-static
502 if [ $? != 0 ]; then sleep 1; continue; fi
503 break
504done
505cd /home/vsoc-01/android-cuttlefish
506dpkg-buildpackage -d -uc -us
507apt-get install -y -f ../cuttlefish-common_*_arm64.deb
508apt-get clean
509usermod -aG cvdnetwork vsoc-01
Tristan Muntsinger5ea7c6a2019-10-15 16:53:08 -0700510chmod 660 /dev/vhost-vsock
511chown root:cvdnetwork /dev/vhost-vsock
512
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700513rm /etc/machine-id
514rm /var/lib/dbus/machine-id
515dbus-uuidgen --ensure
516systemd-machine-id-setup
517
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700518systemctl disable sd-dupe
519rm /etc/systemd/system/sd-dupe.service
520rm /usr/local/bin/sd-dupe
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700521rm /usr/local/bin/install-cleanup
522EOF
Tristan Muntsinger34569112019-10-16 22:10:54 -0700523 chmod +x ${mntdir}/usr/local/bin/install-cleanup
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700524
Tristan Muntsinger34569112019-10-16 22:10:54 -0700525 chroot ${mntdir} /bin/bash << "EOT"
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700526echo "Enabling services..."
Tristan Muntsingerab89e8f2019-10-15 20:30:20 -0700527systemctl enable led
528systemctl enable sd-dupe
Tristan Muntsingerd32ee2b2019-10-15 15:07:00 -0700529
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700530echo "Creating Initial Ramdisk..."
531update-initramfs -c -t -k "5.2.0"
532mkimage -A arm -O linux -T ramdisk -C none -a 0 -e 0 -n uInitrd -d /boot/initrd.img-5.2.0 /boot/uInitrd-5.2.0
533ln -s /boot/uInitrd-5.2.0 /boot/uInitrd
534EOT
535
Tristan Muntsinger34569112019-10-16 22:10:54 -0700536 umount ${mntdir}/sys
537 umount ${mntdir}/dev
538 umount ${mntdir}/proc
539 umount ${mntdir}
540
541 # Turn on journaling
542 tune2fs -O ^has_journal ${IMAGE}
543 e2fsck -fy ${IMAGE} >/dev/null 2>&1
544fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700545
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700546if [ ${USE_IMAGE} -eq 0 ]; then
547 # 32GB eMMC size
Tristan Muntsinger34569112019-10-16 22:10:54 -0700548 end_sector=61071326
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700549 device=/dev/${mmc_dev}
550 devicep=${device}
551
552 sgdisk -Z -a1 ${device}
553 sgdisk -a1 -n:1:64:8127 -t:1:8301 -c:1:loader1 ${device}
554 sgdisk -a1 -n:2:8128:8191 -t:2:8301 -c:2:env ${device}
555 sgdisk -a1 -n:3:16384:24575 -t:3:8301 -c:3:loader2 ${device}
556 sgdisk -a1 -n:4:24576:32767 -t:4:8301 -c:4:trust ${device}
Tristan Muntsinger34569112019-10-16 22:10:54 -0700557 sgdisk -a1 -n:5:32768:${end_sector} -A:5:set:2 -t:5:8305 -c:5:rootfs ${device}
558 if [ ${FLAGS_p5} -eq ${FLAGS_TRUE} ]; then
559 dd if=${IMAGE} of=${devicep}5 bs=1M
560 resize2fs ${devicep}5 >/dev/null 2>&1
561 fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700562else
Tristan Muntsinger34569112019-10-16 22:10:54 -0700563 device=$(losetup -f)
564 devicep=${device}p
565 if [ ${FLAGS_p5} -eq ${FLAGS_FALSE} ]; then
566 fs_end=3G
567 end_sector=-
568 fi
569 if [ ${FLAGS_p5} -eq ${FLAGS_TRUE} ]; then
570 # Minimize rootfs filesystem
571 while true; do
572 out=`sudo resize2fs -M ${IMAGE} 2>&1`
573 if [[ $out =~ "Nothing to do" ]]; then
574 break
575 fi
576 done
577 # Minimize rootfs file size
578 block_count=`sudo tune2fs -l ${IMAGE} | grep "Block count:" | sed 's/.*: *//'`
579 block_size=`sudo tune2fs -l ${IMAGE} | grep "Block size:" | sed 's/.*: *//'`
580 sector_size=512
581 start_sector=32768
582 fs_size=$(( block_count*block_size ))
583 fs_sectors=$(( fs_size/sector_size ))
584 part_sectors=$(( ((fs_sectors-1)/2048+1)*2048 )) # 1MB-aligned
585 end_sector=$(( start_sector+part_sectors-1 ))
586 secondary_gpt_sectors=33
587 fs_end=$(( (end_sector+secondary_gpt_sectors+1)*sector_size ))
588 image_size=$(( part_sectors*sector_size ))
589 truncate -s ${image_size} ${IMAGE}
590 e2fsck -fy ${IMAGE} >/dev/null 2>&1
591 fi
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700592
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700593 # Create final image
Tristan Muntsinger1f28d1f2019-10-16 22:53:55 -0700594 if [ $OVERWRITE -eq 1 ]; then
595 tmpimg=${OVERWRITE_IMAGE}
596 else
597 tmpimg=`mktemp`
598 fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700599 truncate -s ${fs_end} ${tmpimg}
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700600
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700601 # Create GPT
602 sgdisk -Z -a1 ${tmpimg}
603 sgdisk -a1 -n:1:64:8127 -t:1:8301 -c:1:loader1 ${tmpimg}
604 sgdisk -a1 -n:2:8128:8191 -t:2:8301 -c:2:env ${tmpimg}
605 sgdisk -a1 -n:3:16384:24575 -t:3:8301 -c:3:loader2 ${tmpimg}
606 sgdisk -a1 -n:4:24576:32767 -t:4:8301 -c:4:trust ${tmpimg}
607 sgdisk -a1 -n:5:32768:${end_sector} -A:5:set:2 -t:5:8305 -c:5:rootfs ${tmpimg}
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700608
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700609 losetup ${device} ${tmpimg}
610 partx -v --add ${device}
Tristan Muntsinger82c10502019-10-15 14:49:19 -0700611
Tristan Muntsinger34569112019-10-16 22:10:54 -0700612 if [ ${FLAGS_p5} -eq ${FLAGS_TRUE} ]; then
613 dd if=${IMAGE} of=${devicep}5 bs=1M
614 fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700615fi
Tristan Muntsinger34569112019-10-16 22:10:54 -0700616if [ ${FLAGS_p1} -eq ${FLAGS_TRUE} ]; then
617 dd if=${idbloader} of=${devicep}1
618fi
619if [ ${FLAGS_p2} -eq ${FLAGS_TRUE} ]; then
620 dd if=${bootenv} of=${devicep}2
621fi
622if [ ${FLAGS_p3} -eq ${FLAGS_TRUE} ]; then
623 dd if=${ANDROID_BUILD_TOP}/external/u-boot/u-boot.itb of=${devicep}3
624fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700625if [ ${USE_IMAGE} -eq 1 ]; then
626 chown $SUDO_USER:`id -ng $SUDO_USER` ${tmpimg}
Tristan Muntsinger1f28d1f2019-10-16 22:53:55 -0700627 if [ $OVERWRITE -eq 0 ]; then
628 mv ${tmpimg} ${IMAGE}
629 fi
Tristan Muntsingere4eeded2019-10-15 20:26:15 -0700630 partx -v --delete ${device}
631 losetup -d ${device}
632fi